#ifndef __bgplogcon_h_
#define __bgplogcon_h_
#include "bgplog.h"

namespace BGPHist {
    
class BGPLogCon: public BGPLog {
public:
    BGPLogCon();
    virtual ~BGPLogCon();
    virtual void open(BGPPeer *peer,const MSG_Open *);
    virtual void close(BGPPeer *peer);
    virtual void txt(BGPPeer *peer,const char *);
    virtual void exception(BGPPeer *peer,const BGPException *);
    virtual void notification(BGPPeer *peer,const MSG_Notify *);
    virtual void keepalive(BGPPeer *peer);
    virtual void nlri(BGPPeer *peer,const MSG_UpdateAttr &,const IPNets & );
    virtual void withdraw(BGPPeer *peer,const MSG_UpdateAttr &,const IPNets & );
    virtual void nlri_ipv4m(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void withdraw_ipv4m(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void nlri_ipv4lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_ipv4lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_vpnv4u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_vpnv4u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_ipv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void withdraw_ipv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void nlri_ipv6lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_ipv6lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_vpnv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_vpnv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_l2vpn(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_l2vpn(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
};

};

#endif
