#ifndef __bgplogmysql_h_
#define __bgplogmysql_h_
#include "bgplog.h"

namespace BGPHist {
class BGPLogMy: public BGPLog {
protected:
#ifdef MYSQLSTMT
    class MyStmt;
    typedef std::map<int,MyStmt *> TSQ;
    TSQ vSQ;
    void prepare_vSQ();
#endif
    void logtxt(unsigned uCode,const char *);
    void exec_ipv4(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    void exec_ipv4l(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    void exec_vpnv4(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    void exec_ipv6(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    void exec_ipv6l(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    void exec_vpnv6(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    void exec_l2vpn(unsigned state,unsigned kind,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
public:
    void * pmc;
    const char *myhost,*mydb,*myuser,*mypwd;
    unsigned uSrcId;
    BGPLogMy(const char *_myhost,const char *_mydb,const char *_myuser,const char *_mypwd,const char *_peerip,unsigned int _asn);
    virtual ~BGPLogMy();
    virtual void open(BGPPeer *peer,const MSG_Open *);
    virtual void close(BGPPeer *peer);
    virtual void txt(BGPPeer *peer,const char *);
    virtual void exception(BGPPeer *peer,const BGPException *);
    virtual void notification(BGPPeer *peer,const MSG_Notify *);
    virtual void keepalive(BGPPeer *peer);
    virtual void nlri(BGPPeer *peer,const MSG_UpdateAttr &,const IPNets & );
    virtual void withdraw(BGPPeer *peer,const MSG_UpdateAttr &,const IPNets & );
    virtual void nlri_ipv4m(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void withdraw_ipv4m(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void nlri_ipv4lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_ipv4lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_vpnv4u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_vpnv4u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_ipv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void withdraw_ipv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPNets & );
    virtual void nlri_ipv6lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_ipv6lu(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_vpnv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_vpnv6u(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void nlri_l2vpn(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
    virtual void withdraw_l2vpn(BGPPeer *peer,const MSG_UpdateAttr &,const IPAddress & nexthop,const IPTagNets & );
};

};

#endif
