#ifndef __bgppeer_h_
#define __bgppeer_h_
#include "config.h"
#include "bgpcommon.h"
#include "bgpsock.h"

class iosockinet;
namespace BGPHist {

class BGPLog;
class BGPPeer {
protected:
    int state;
    bool bIs32bitASN,bIsIPV6;
    BGPLog *log;
    Socket sock;
    int iFD;bool bFDMode,bFEof;
    unsigned uTimeout;
    bool read_bgpmsg();
    void readdata(void *,size_t);
public:
    BGPASN asnMy,asnPeer;
    unsigned uRouterId;
    unsigned short uHoldTime;
    std::string sPeer;
    BGPPeer(BGPLog *);
    ~BGPPeer();
    bool connect();
    bool eof();
    void playfile(int );
    void lifecycle();
    void close();
    static void listen(BGPLog *,unsigned myaddr,BGPASN myasn);
    static void connectTo(BGPLog *,const char *,BGPASN asn);
};

};

#endif
