#ifndef __sockpair_h_
#define __sockpair_h_
#include <stdlib.h>
#include <exception>
#include <string>

namespace BGPHist {
class SocketException: public std::exception {
public:
	int errcode;
	std::string msg;
	SocketException();
	SocketException(int );
	SocketException(int ,const char *);
	SocketException(const char *,...);
	void setStr(const char *);
    virtual const char* what() const throw();
    virtual ~SocketException() throw();
};

enum SocketOpenMode {somCheckURI,somConnect,somBind};
class Socket {
    mutable bool feof;
    void setsckopts(int iSocket);
public:
	mutable int iSocket;
	int iSocketType;
	mutable void * saPermanent;
	unsigned int uSaLen;
	struct {
	unsigned uOpt_keepalive,
	uOpt_sndbuf,
	uOpt_rcvbuf;
    } sockopts;
	Socket();
	Socket(const Socket &);
	~Socket();
	size_t Write(const void * buf,size_t );
	bool eof() const;
	bool is_writeready(float fTimeout=0);
	bool is_readready(float fTimeout=0);
	size_t Read(void * buf,size_t );
	Socket & operator=(const Socket &);
	bool valid() const{return iSocket>=0;}
	void close();
	void release() const;
	bool accept(Socket &);
	void setSocket(int );
	bool openSocket(const char *,SocketOpenMode mode);
};


};

#endif
